SystemOrganization addCategory: #'ToolBuilder-Morphic'!

ListItemWrapper subclass: #PluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTreeItemNode commentStamp: 'ar 2/12/2005 04:37' prior: 0!
Tree item for PluggableTreeMorph.!

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
acceptDroppingObject: anotherItem
	^model dropNode: anotherItem on: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
asString
	^model printNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
balloonText
	^model balloonTextForNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:02'!
canBeDragged
	^model isDraggableNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:03'!
contents
	^model contentsOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
hasContents
	^model hasNodeContents: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:04'!
icon
	^model iconOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
wantsDroppedObject: anotherItem
	^model wantsDroppedNode: anotherItem on: self! !

ModelDependentDialogWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'statusValue buttons contentMorph applyChangesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableDialogWindow commentStamp: 'gvc 8/8/2007 14:08' prior: 0!
Pluggable form of dialog window supporting custom selector on model for applying changes along with configurable content and buttons.!

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
applyChanges
	"Apply the changes."

	super applyChanges.
	self applyChangesSelector ifNotNil: [:s |
		self model perform: s withEnoughArguments: {self}]! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector
	"Answer the value of applyChangesSelector"

	^ applyChangesSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector: anObject
	"Set the value of applyChangesSelector"

	applyChangesSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons
	"Answer the value of buttons"

	^ buttons! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons: anObject
	"Set the value of buttons"

	buttons := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:03'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:02'!
newButtons
	"Answer  the plugged buttons."

	^self buttons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/9/2007 13:36'!
newContentMorph
	"Answer the plugged content."
	
	^self contentMorph! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue
	^statusValue! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue: val
	statusValue := val! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:05'!
useDefaultOKButton
	"Set the buttons to be just an OK button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton isDefault: true}! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useDefaultOKCancelButton
	"Set the buttons to be a default OK button and a cancel button.
	Only effective before the model is set."
	
	self buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useOKDefaultCancelButton
	"Set the buttons to be an OK button and a default cancel button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton. self newCancelButton isDefault: true}! !

SystemWindow subclass: #PluggableSystemWindow
	instanceVariableNames: 'getLabelSelector getChildrenSelector children closeWindowSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableSystemWindow commentStamp: 'ar 2/11/2005 20:14' prior: 0!
A pluggable system window. Fixes the issues with label retrieval and adds support for changing children.!

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'md 8/31/2005 07:59'!
addPaneMorph: aMorph
	self addMorph: aMorph fullFrame: aMorph layoutFrame! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector
	^closeWindowSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector: aSymbol
	closeWindowSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'initialization' stamp: 'ar 9/17/2005 21:08'!
delete
	closeWindowSelector ifNotNil:[model perform: closeWindowSelector].
	super delete.
! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getLabelSelector
	^getLabelSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:53'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol.
	self update: aSymbol.! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:52'!
label
	^label contents! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:51'!
label: aString
	self setLabel: aString.! !

!PluggableSystemWindow methodsFor: 'updating' stamp: 'ar 2/11/2005 20:15'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue:[self setLabel: (model perform: getLabelSelector)].
	what == getChildrenSelector ifTrue:[
		children ifNil:[children := #()].
		self removeAllMorphsIn: children.
		children := model perform: getChildrenSelector.
		self addAllMorphs: children.
		children do:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].
	^super update: what! !

Model subclass: #ChooserTool
	instanceVariableNames: 'label items index builder window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!ChooserTool commentStamp: 'ar 12/9/2009 23:46' prior: 0!
A simple chooser tool for Morphic. Useful when menus just get too long.!

!ChooserTool class methodsFor: 'tools' stamp: 'ar 12/9/2009 22:25'!
chooseFrom: labelList title: aString
	^self new chooseFrom: labelList title: aString! !

!ChooserTool class methodsFor: 'opening' stamp: 'ar 12/9/2009 22:08'!
open
	^ToolBuilder open: self! !

!ChooserTool methodsFor: 'actions' stamp: 'ar 12/9/2009 22:26'!
accept
	"Accept current selection and move on"
	builder ifNotNil:[:bldr|
		builder := nil.
		bldr close: window].! !

!ChooserTool methodsFor: 'toolbuilder' stamp: 'ar 12/9/2009 22:03'!
buildButtonsWith: aBuilder
	| panel button |
	panel := aBuilder pluggablePanelSpec new
		model: self;
		layout: #proportional;
		children: OrderedCollection new.
	button := aBuilder pluggableButtonSpec new.
	button
				model: self; 
				label: 'Accept';
				action: #accept;
				enabled: #canAccept;
				frame: (0.0 @ 0.0 corner: 0.48@1).
	panel children add: button.

	button := aBuilder pluggableButtonSpec new.
	button
				model: self; 
				label: 'Cancel';
				action: #cancel;
				frame: (0.52 @ 0.0 corner: 1@1).
	panel children add: button.
	^panel! !

!ChooserTool methodsFor: 'toolbuilder' stamp: 'jcg 12/12/2009 10:34'!
buildChooserListWith: builder
	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #itemList; 
		getIndex: #itemListIndex; 
		setIndex: #itemListIndex:; 
		doubleClick: #accept;
		autoDeselect: false.
	^listSpec
! !

!ChooserTool methodsFor: 'toolbuilder' stamp: 'ar 12/9/2009 21:52'!
buildWindowWith: builder
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: #labelString.
	windowSpec children: OrderedCollection new.
	^windowSpec! !

!ChooserTool methodsFor: 'toolbuilder' stamp: 'nice 12/27/2009 02:52'!
buildWindowWith: builder specs: specs
	| windowSpec |
	windowSpec := self buildWindowWith: builder.
	specs do:[:assoc|
		| rect action widgetSpec |
		rect := assoc key.
		action := assoc value.
		widgetSpec := action value.
		widgetSpec ifNotNil:[
			widgetSpec frame: rect.
			windowSpec children add: widgetSpec]].
	^windowSpec! !

!ChooserTool methodsFor: 'toolbuilder' stamp: 'ar 12/9/2009 23:47'!
buildWith: aBuilder
	| windowSpec |
	builder := aBuilder.
	windowSpec := self buildWindowWith: builder specs: {
		(0@0 corner: 1@0.9) -> [self buildChooserListWith: builder].
		(0@0.9 corner: 1@1) -> [self buildButtonsWith: builder].
	}.
	windowSpec closeAction: #closed.
	windowSpec extent: 250@350.
	^builder build: windowSpec! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:17'!
canAccept
	^self itemListIndex > 0! !

!ChooserTool methodsFor: 'actions' stamp: 'ar 12/9/2009 22:24'!
cancel
	"Cancel the dialog and move on"
	index := 0.
	builder ifNotNil:[builder close: window].! !

!ChooserTool methodsFor: 'initialize' stamp: 'ar 12/9/2009 23:50'!
chooseFrom: labelList title: aString
	builder := ToolBuilder default.
	self itemList: labelList.
	self label: aString.
	window := ToolBuilder default open: self.
	window center: Sensor cursorPoint.
	window setConstrainedPosition: (Sensor cursorPoint - (window fullBounds extent // 2)) hangOut: false.
	builder runModal: window.
	^self itemListIndex! !

!ChooserTool methodsFor: 'actions' stamp: 'ar 12/9/2009 22:26'!
closed
	"Cancel the dialog and move on"
	builder ifNotNil:[index := 0].! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:08'!
itemList
	^items! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:08'!
itemList: aCollection
	items := aCollection.
	self changed: #items.! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:15'!
itemListIndex
	^index ifNil:[0]! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:16'!
itemListIndex: newIndex
	index := newIndex.
	self changed: #itemListIndex.
	self changed: #canAccept.! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:07'!
label
	^label! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:07'!
label: aString
	label := aString.! !

!ChooserTool methodsFor: 'accessing' stamp: 'ar 12/9/2009 22:06'!
labelString
	^label! !

SimpleHierarchicalListMorph subclass: #PluggableTreeMorph
	instanceVariableNames: 'roots selectedWrapper getRootsSelector getChildrenSelector hasChildrenSelector getLabelSelector getIconSelector getSelectedPathSelector getHelpSelector dropItemSelector wantsDropSelector dragItemSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTreeMorph commentStamp: 'ar 2/12/2005 04:38' prior: 0!
A pluggable tree morph.!

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'mvdg 2/14/2007 14:58'!
acceptDroppingMorph: aMorph event: evt
	| item dropTarget |
	dropItemSelector ifNil:[^self].
	item := aMorph passenger.
	dropTarget := (self itemFromPoint: evt position) withoutListWrapper.
	model perform: dropItemSelector with: item with: dropTarget.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:19'!
balloonTextForNode: node
	getHelpSelector ifNil:[^nil].
	^model perform: getHelpSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 01:13'!
contentsOfNode: node
	| children |
	getChildrenSelector ifNil:[^#()].
	children := model perform: getChildrenSelector with: node item.
	^children collect:[:item| PluggableTreeItemNode with: item model: self]! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector
	^dragItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector: aSymbol
	dragItemSelector := aSymbol.
	aSymbol ifNotNil:[self dragEnabled: true].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
dropItemSelector
	^dropItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/9/2007 21:37'!
dropItemSelector: aSymbol
	dropItemSelector := aSymbol.
	aSymbol ifNotNil:[self dropEnabled: true].! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
dropNode: srcNode on: dstNode
	dropItemSelector ifNil:[^nil].
	model perform: dropItemSelector with: srcNode item with: dstNode item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector
	^getHelpSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector: aSymbol
	getHelpSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector
	^getIconSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector: aSymbol
	getIconSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector
	^getLabelSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:57'!
getMenuSelector
	^getMenuSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector
	^getRootsSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector: aSelector
	getRootsSelector := aSelector.
	self update: getRootsSelector.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector
	^getSelectedPathSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector: aSymbol
	getSelectedPathSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
hasChildrenSelector
	^hasChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
hasChildrenSelector: aSymbol
	hasChildrenSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:11'!
hasNodeContents: node
	hasChildrenSelector ifNil:[^node contents isEmpty not].
	^model perform: hasChildrenSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
iconOfNode: node
	getIconSelector ifNil:[^nil].
	^model perform: getIconSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:02'!
isDraggableNode: node
	^true! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector
	^keystrokeActionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector: aSymbol
	keystrokeActionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
printNode: node
	getLabelSelector ifNil:[^node item printString].
	^model perform: getLabelSelector with: node item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:22'!
roots
	^roots! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 01:11'!
roots: anArray
	roots := anArray collect:[:item| PluggableTreeItemNode with: item model: self].
	self list: roots.! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 17:29'!
selectPath: path in: listItem
	path isEmpty ifTrue: [^self setSelectedMorph: nil].
	listItem withSiblingsDo: [:each | 
		(each complexContents item = path first) ifTrue: [
			each isExpanded ifFalse: [
				each toggleExpandedState.
				self adjustSubmorphPositions.
			].
			each changed.
			path size = 1 ifTrue: [
				^self setSelectedMorph: each
			].
			each firstChild ifNil: [^self setSelectedMorph: nil].
			^self selectPath: path allButFirst in: each firstChild
		].
	].
	^self setSelectedMorph: nil

! !

!PluggableTreeMorph methodsFor: 'selection' stamp: 'LaurentLaffont 3/17/2010 21:41'!
setSelectedMorph: aMorph
	selectedWrapper := aMorph complexContents.
	self selection: selectedWrapper.
	setSelectionSelector ifNotNil:[
		model 
			perform: setSelectionSelector 
			with: (selectedWrapper ifNotNil:[selectedWrapper item]).
	].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'LaurentLaffont 3/17/2010 21:42'!
setSelectedSelector
	^setSelectionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'LaurentLaffont 3/17/2010 21:42'!
setSelectedSelector: aSymbol
	setSelectionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'stephaneDucasse 7/17/2010 16:39'!
startDrag: evt 
	| ddm itemMorph passenger |
	self dragEnabled
		ifTrue: [itemMorph := scroller submorphs
						detect: [:any | any highlightedForMouseDown]
						ifNone: []].
	(itemMorph isNil
			or: [evt hand hasSubmorphs])
		ifTrue: [^ self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph
		ifTrue: [self setSelectedMorph: itemMorph].
	passenger := self model perform: dragItemSelector with: itemMorph withoutListWrapper.
	passenger
		ifNotNil: [ddm := TransferMorph withPassenger: passenger from: self.
			ddm dragTransferType: #dragTransfer.
			self theme settings dragNDropWithAnimation
				ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
			evt hand grabMorph: ddm].
	evt hand releaseMouseFocus: self! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 19:11'!
update: what
	what ifNil:[^self].
	what == getRootsSelector ifTrue:[
		self roots: (model perform: getRootsSelector)
	].
	what == getSelectedPathSelector ifTrue:[
		^self selectPath: (model perform: getSelectedPathSelector)
			in: (scroller submorphs at: 1 ifAbsent: [^self]) 
	].
	^super update: what! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
wantsDropSelector
	^wantsDropSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:27'!
wantsDropSelector: aSymbol
	wantsDropSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'stephaneDucasse 7/17/2010 16:39'!
wantsDroppedMorph: aMorph event: anEvent
	aMorph dragTransferType == #dragTransfer ifFalse: [^false].
	dropItemSelector ifNil: [^false].
	wantsDropSelector ifNil: [^true].
	^ (model perform: wantsDropSelector with: aMorph passenger)! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 7/15/2005 12:11'!
wantsDroppedNode: srcNode on: dstNode
	dropItemSelector ifNil:[^false].
	wantsDropSelector ifNil:[^true].
	^(model perform: wantsDropSelector with: srcNode with: dstNode) == true! !

UIManager subclass: #MorphicUIManager
	uses: TEasilyThemed
	instanceVariableNames: 'interactiveParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!MorphicUIManager commentStamp: 'ar 2/11/2005 21:52' prior: 0!
The Morphic ui manager.!

MorphicUIManager class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!MorphicUIManager class methodsFor: 'accessing' stamp: 'alain.plantec 5/30/2008 13:55'!
isActiveManager
	"Answer whether I should act as the active ui manager"
	^ true! !

!MorphicUIManager methodsFor: 'private' stamp: 'JuanVuletich 10/22/2010 14:04'!
buildMorphicNotifierFor: aDebugger labelled: label message: messageString
	| notifyPane window extentToUse row|
	aDebugger expandStack.
	window := (PreDebugWindow labelled: label) model: aDebugger.
	extentToUse := 450 @ 156. "nice and wide to show plenty of the error msg"
	window
		addMorph: (row := aDebugger buttonRowForPreDebugWindow: window)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@row minExtent y)).
	row color: Color transparent.
	messageString notNil
		ifFalse:
			[notifyPane := PluggableListMorph on: aDebugger list: #contextStackList
				selected: #contextStackIndex changeSelected: #debugAt:
				menu: nil keystroke: nil]
		ifTrue:
			[notifyPane := PluggableTextMorph on: aDebugger text: nil accept: nil
				readSelection: nil menu: #debugProceedMenu:.
			notifyPane editString: (aDebugger preDebugNotifierContentsFrom: messageString);
				askBeforeDiscardingEdits: false].
	window
		addMorph: notifyPane
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@24 corner: 0@0)).
	window setBalloonTextForCloseBox.
	window openInWorldExtent: extentToUse.
	window currentWorld displayWorld. "helps with interrupt not working somehow."
	^window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 15:15'!
checkForNewDisplaySize

	"Check whether the screen size has changed and if so take appropriate actions"

	Display extent = DisplayScreen actualScreenSize ifTrue: [^ Display].
	DisplayScreen startUp.
	World restoreMorphicDisplay.
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:55'!
chooseDirectory: label from: dir
	"Answer the user choice of a directory."
	
	^ self theme  
		chooseDirectoryIn: self modalMorph
		title: (label ifNil: ['Choose Directory' translated])
		path: (dir ifNotNil: [dir pathName])! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
chooseFileMatching: patterns label: label
	"Let the user choose a file matching the given patterns"
	
	^ self theme
		chooseFileNameIn: self modalMorph
		title: (label ifNil: ['Choose File' translated])
		patterns: patterns
		path: nil
		preview: false! !

!MorphicUIManager methodsFor: 'services' stamp: 'StephaneDucasse 7/17/2010 13:10'!
chooseFrom: aList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^(self
		chooseFrom: aList
		values: nil
		lines: linesArray
		message: messageString
		title: aString) ifNil: [0]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 7/17/2010 13:11'!
chooseFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^(self
		chooseFrom: aList
		values: nil
		lines: linesArray
		title: aString) ifNil: [0]! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:56'!
chooseFrom: labelList values: valueList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^ self theme
		chooseIn: self modalMorph
		title: aString
		message: messageString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:55'!
chooseFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^ self theme  
		chooseIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'services' stamp: 'StephaneDucasse 7/17/2010 13:12'!
chooseOrRequestFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^self
		chooseOrRequestFrom: aList
		values: aList
		lines: linesArray
		title: aString! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:56'!
chooseOrRequestFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^ self theme 
		chooseOrRequestIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:56'!
confirm: aStringOrText
	"Put up a question dialog (without cancel) with the text queryString.
	Answer true if the response is yes, false if no.
	This is a modal question--the user must respond yes or no."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer].
	^ self theme 
		questionWithoutCancelIn: self modalMorph
		text: aStringOrText
		title: 'Question' translated! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:56'!
confirm: aStringOrText orCancel: cancelBlock
	"Put up a question dialog (with cancel) with the text queryString.
	Answer true if the response is yes, false if no.
	Answer the value of the cancel block if cancelled.
	This is a modal question--the user must respond yes or no or cancel."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #cancel ifTrue: [cancelBlock value] ifFalse: [answer]].
	^( self theme 
		questionIn: self modalMorph
		text: aStringOrText
		title: 'Question' translated) ifNil: cancelBlock! !

!MorphicUIManager methodsFor: 'services' stamp: 'GaryChambers 8/23/2010 12:13'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice 
	"Put up a yes/no menu with caption queryString. The actual wording for the two choices will be as provided in the trueChoice and falseChoice parameters. Answer true if the response is the true-choice, false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."
	
	^self
		confirm: queryString
		trueChoice: trueChoice
		falseChoice: falseChoice
		cancelChoice: nil
		default: nil! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:57'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice cancelChoice: cancelChoice default: defaultOption
	"Put up a yes/no/cancel menu with caption queryString. The actual wording for the choices will be as provided in the trueChoice, falseChoice and cancelChoice parameters.
	defaultOption should be one of true, false or nil to set the default button.
	Answer true if the response is the true-choice, false if it's the false-choice, nil if the cancelChoice.
	This is a modal question -- the user must respond."
	
	(ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
		^answer].
	^ self theme  
		customQuestionIn: self modalMorph
		text: queryString
		yesText: trueChoice
		noText: falseChoice
		cancelText: cancelChoice
		default: defaultOption
		title: 'Question' translated! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 11/1/2010 15:17'!
currentWorld
	ActiveWorld ifNotNil: [^ActiveWorld].
	^World! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 2/28/2005 17:13'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	^ProgressInitiationException 
		display: titleString
		at: aPoint 
		from: minVal 
		to: maxVal 
		during: workBlock! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'MarcusDenker 10/30/2010 17:18'!
edit: aText label: labelString accept: anAction
	"Open an editor on the given string/text"

	^(Workspace openLabel: labelString)
		acceptContents:  aText;
		acceptAction: anAction;
		yourself.
	! !

!MorphicUIManager methodsFor: 'services' stamp: 'StephaneDucasse 7/17/2010 13:13'!
enterOrRequestFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^self
		enterOrRequestFrom: aList
		values: aList
		lines: linesArray
		title: aString! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:56'!
enterOrRequestFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^ self theme 
		enterOrRequestIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 14:51'!
explorer: anObjectExplorer for: anObject withLabel: label 
	| window listMorph |
	anObjectExplorer rootObject: anObject.
	window := (SystemWindow labelled: label) model: anObjectExplorer.
	window addMorph: (listMorph := SimpleHierarchicalListMorph 
			on: anObjectExplorer
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: #explorerKey:from:)
		frame: (0@0 corner: 1@0.8).
	window addMorph: ((PluggableTextMorph on: anObjectExplorer text: #trash accept: #trash:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
					askBeforeDiscardingEdits: false)
		frame: (0@0.8 corner: 1@1).
	listMorph autoDeselect: false.
     ^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 15:12'!
fileDoesNotExistsDefaultAction: anException

	^anException readOnly
		ifTrue: [StandardFileStream readOnlyFileDoesNotExistUserHandling: anException fileName]
		ifFalse: [StandardFileStream fileDoesNotExistUserHandling: anException fileName]
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 20:14'!
fileExistsDefaultAction: anException

	^ anException fileClass fileExistsUserHandling: anException fileName! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'Pavel.Krivanek 10/28/2008 10:46'!
fontFromUser: priorFont	
	
	^ StrikeFont fromUser: priorFont allowKeyboard: true! !

!MorphicUIManager methodsFor: 'bitBlt' stamp: 'Pavel.Krivanek 10/28/2008 11:02'!
grafPort	
	
	^ Display defaultBitBltClass asGrafPort! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:56'!
inform: aStringOrText
	"Display a message for the user to read and then dismiss."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^true].
	^ self theme 
		messageIn: self modalMorph
		text: aStringOrText
		title: 'Information' translated! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 7/17/2010 13:13'!
informUserDuring: aBlock
	"Display a message as progress	during execution of the given block."
	"UIManager default informUserDuring: [:bar|
		#('one' 'two' 'three') do: [:info|
			bar value: info.
			1 to: 100 do: [:v |
				bar value: v.
				(Delay forMilliseconds: 20) wait]]]"
	
	self
		displayProgress: ''
		at: Sensor cursorPoint
		from: 1 to: 100
		during: [:bar | aBlock value: bar]! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'pavel.krivanek 11/21/2008 17:30'!
interactiveParser
	"Answer the value of interactiveParser"

	^ interactiveParser! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'pavel.krivanek 11/21/2008 17:30'!
interactiveParser: anObject
	"Set the value of interactiveParser"

	interactiveParser := anObject! !

!MorphicUIManager methodsFor: 'settings' stamp: 'stephaneDucasse 5/8/2010 20:00'!
interactiveParserFor: requestor
	"during Morphic loading the interactive parser must be disabled"

	(interactiveParser = false) ifTrue: [ ^ false ].  "can be nil"
	^ requestor notNil! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 20:17'!
lowSpaceWatcherDefaultAction: preemptedProcess

	Project interruptName: 'Space is low' preemptedProcess: preemptedProcess! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 18:17'!
menuClass
	^MenuMorph! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 09:10'!
messageNames: aMessageNames inMorphicWindowWithInitialSearchString: initialString
	"Answer a morphic window with the given initial search string, nil if none"

"MessageNames openMessageNames"

	| window selectorListView secondDivider horizDivider searchPane searchButton searchTextMorph searchColumn|
	window := (StandardWindow labelled: 'Message Names' translated) model: aMessageNames.
	secondDivider := 0.5.
	horizDivider := 0.5.

	searchTextMorph := window
		newTextEntryFor: aMessageNames
		getText: #searchString
		setText: #searchString:from:
		help: nil.
	searchTextMorph
		ghostText: 'type here, then click Search' translated;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		askBeforeDiscardingEdits: false.
	searchButton := window
		newButtonFor: aMessageNames
		action: #doSearchFrom:
		label: 'Search' translated
		help: 'Type some letters into the pane at right, and then press this Search button (or hit RETURN) and all method selectors that match what you typed will appear in the list pane below.  Click on any one of them, and all the implementors of that selector will be shown in the right-hand pane, and you can view and edit their code without leaving this tool.' translated.
	searchButton arguments: {searchTextMorph}.
	
	searchPane := window
		newRow: {searchButton. searchTextMorph}.
	initialString isEmptyOrNil ifFalse:
		[searchTextMorph setText: initialString].

	selectorListView := window
		newListFor: aMessageNames
		list: #selectorList
		selected:  #selectorListIndex
		changeSelected: #selectorListIndex:
		help: nil.
	selectorListView
		getMenuSelector: #selectorListMenu:;
		keystrokeActionSelector: #selectorListKey:from:;
		menuTitleSelector: #selectorListMenuTitle;
		useSquareCorners.
	searchColumn := window newColumn: {searchPane. selectorListView}.
	searchColumn cellInset: ProportionalSplitterMorph splitterWidth.
	window
		addMorph: searchColumn
		frame: (0 @ 0 corner: horizDivider @ secondDivider);
		addMorph: aMessageNames buildMorphicMessageList
		frame: (horizDivider @ 0 corner: 1@ secondDivider);
		rememberKeyboardFocus: searchTextMorph.

	aMessageNames 
		addLowerPanesTo: window 
		at: (0 @ secondDivider corner: 1@1) 
		with: nil.

	initialString isEmptyOrNil ifFalse:
		[aMessageNames searchString: initialString].
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/18/2010 09:51'!
messageSet: aMessageSet inMorphicWindowLabeled: labelString
	| window listFraction |
	window := (SystemWindow labelled: labelString) model: aMessageSet.
	listFraction := 0.4.
	window addMorph: aMessageSet buildMorphicMessageList frame: (0@0 extent: 1@listFraction).
	aMessageSet 
		addLowerPanesTo: window 
		at: (0@listFraction corner: 1@1) 
		with: nil.

	window setUpdatablePanesFrom: #(messageList).
	^ window! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'StephaneDucasse 7/17/2010 13:15'!
modalMorph
	"Answer the morph that should be used to handle modality."
	| sender receiver foundWorld |
	sender := thisContext sender.
	foundWorld := false.
	[foundWorld or: [sender isNil]]
		whileFalse: [receiver := sender receiver.
			((sender selector = #invokeWorldMenu:)
					or: [receiver == World
							and: [sender selector == #handleEvent:
									or: [sender selector == #findWindow:]]])
				ifTrue: [foundWorld := true]
				ifFalse: [sender := sender sender]].
	foundWorld
		ifTrue: [^ receiver world
				ifNil: [World]].
	^ SystemWindow topWindow
		ifNil: [World]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:56'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	
	(ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme 
		textEditorIn: self modalMorph
		text: queryString
		title: 'Information Required' translated
		entryText: defaultAnswer
		entryHeight: answerHeight)
			ifNotNil: [:text | text asString]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 13:14'!
newDisplayDepthNoRestore: pixelSize

	"Change depths.  Check if there is enough space!!  , di"
	| area need |
	pixelSize = Display depth ifTrue: [^ Display  "no change"].
	pixelSize abs < Display depth ifFalse:
		["Make sure there is enough space"
		area := Display boundingBox area. "pixels"
		need := (area * (pixelSize abs - Display depth) // 8)  "new bytes needed"
				+ Smalltalk lowSpaceThreshold.
		(Smalltalk garbageCollectMost <= need
			and: [Smalltalk garbageCollect <= need])
			ifTrue: [self error: 'Insufficient free space']].
	Display setExtent: Display extent depth: pixelSize.

	DisplayScreen startUp! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 2/25/2011 17:53'!
newMenuIn: aThemedMorph for: aModel
	"Answer a new menu."
	"UIManager default"
	^self theme 
		newMenuIn: aThemedMorph for: aModel! !

!MorphicUIManager methodsFor: 'events' stamp: 'Pavel.Krivanek 10/28/2008 11:24'!
onDebug: process context: context title: title full: bool	
	
	| topCtxt |	
	
	topCtxt := process isActiveProcess ifTrue: [thisContext] ifFalse: [process suspendedContext].
	(topCtxt hasContext: context) ifFalse: [^ self error: 'context not in process'].	
	ToolSet debug: process context: context label: title contents: nil fullView: bool.! !

!MorphicUIManager methodsFor: 'events' stamp: 'Pavel.Krivanek 10/28/2008 11:22'!
onEventSensorStartup: anEventSensor

	anEventSensor flushAllButDandDEvents! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'MarcusDenker 4/29/2011 00:36'!
onFontsChanged

	StringMorph allSubInstancesDo: [ :s | s layoutChanged ].
	TextMorph allSubInstancesDo: [ :s | s layoutChanged ].
	SystemWindow allInstancesDo: [ :w | [ w update: #relabel ] on: Error do: [ :ex | ] ].
	World ifNotNil: [ :w | w changed ].! !

!MorphicUIManager methodsFor: 'events' stamp: 'nice 1/5/2010 15:59'!
onPrimitiveError: aString
																																																																 	
																																																																	
	(String
		streamContents: 
			[:s | | context |
			s nextPutAll: '***System error handling failed***'.
			s cr; nextPutAll: aString.
			context := thisContext sender sender.
			20 timesRepeat: [context == nil ifFalse: [s cr; print: (context := context sender)]].
			s cr; nextPutAll: '-------------------------------'.
			s cr; nextPutAll: 'Type CR to enter an emergency evaluator.'.
			s cr; nextPutAll: 'Type any other character to restart.'])
		displayAt: 0 @ 0.
	[Sensor keyboardPressed] whileFalse.
	Sensor keyboard = Character cr ifTrue: [Transcripter emergencyEvaluator].
	
	World install "init hands and redisplay"! !

!MorphicUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 16:37'!
onSnapshot: resuming
	"The resuming argument is true when image boots from disk,
	and false, if user just did an image snapshot."
	
	"if we resuming, check if we're still interactive "
	
	(resuming and: [ Smalltalk isInteractive not ]) ifTrue: [
			^ self nonInteractiveManager onSnapshot: resuming ].

	SystemWindow wakeUpTopWindowUponStartup! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:50'!
openBrowser: aBrowser asMorphClassEditing: editString
	"Create a pluggable version a Browser on just a single class."
	| window dragNDropFlag hSepFrac switchHeight mySingletonClassList |

	window := (SystemWindow labelled: 'later') model: aBrowser.
	dragNDropFlag := true.
	hSepFrac := 0.3.
	switchHeight := 25.
	mySingletonClassList := PluggableListMorph on: aBrowser list: #classListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	mySingletonClassList enableDragNDrop: dragNDropFlag.

	aBrowser 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.
	window 
		addMorph: mySingletonClassList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).
	
	aBrowser 
		addMorphicSwitchesTo: window 
		at: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).

	window 
		addMorph: aBrowser buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	window 
		addMorph: aBrowser buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	window setUpdatablePanesFrom: #(messageCategoryList messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:37'!
openBrowser: aBrowser asMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window hSepFrac |

	hSepFrac := 0.4.
	window := (SystemWindow labelled: 'later') model: aBrowser.

"The method SystemWindow>>addMorph:fullFrame: checks scrollBarsOnRight, then adds the morph at the back if true, otherwise it is added in front. But flopout hScrollbars need the lowerpanes to be behind the upper ones in the draw order. Hence the value of scrollBarsOnRight affects the order in which the lowerpanes are added. "
	window theme settings scrollBarsOnRight ifFalse:
		[aBrowser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString].
		
	window 
		addMorph: aBrowser buildMorphicSystemCatList
		frame: (0@0 corner: 0.25@hSepFrac).
	aBrowser 
		addClassAndSwitchesTo: window 
		at: (0.25@0 corner: 0.5@hSepFrac)
		plus: 0.
	window 
		addMorph: aBrowser buildMorphicMessageCatList
		frame: (0.5@0 extent: 0.25@hSepFrac).
	window addMorph: aBrowser buildMorphicMessageList
		frame: (0.75@0 extent: 0.25@hSepFrac).

	window theme settings scrollBarsOnRight ifTrue:
		[aBrowser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString].

	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:41'!
openBrowser: aBrowser asMorphMessageEditing: editString
	"Create a pluggable version a Browser that shows just one message"
	| window mySingletonMessageList verticalOffset nominalFractions |
	window := (SystemWindow labelled: 'later') model: aBrowser.

	mySingletonMessageList := PluggableListMorph on: aBrowser list: #messageListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	mySingletonMessageList enableDragNDrop: true.
	verticalOffset := 25.
	nominalFractions := 0@0 corner: 1@0.
	window 
		addMorph: mySingletonMessageList
		fullFrame: (
			LayoutFrame 
				fractions: nominalFractions 
				offsets: (0@0 corner: 0@verticalOffset)
		).

	verticalOffset := aBrowser addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset := aBrowser addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (aBrowser buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).

	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:45'!
openBrowser: aBrowser asMorphMsgCatEditing: editString
	"Create a pluggable version a Browser on just a message category."

	| window hSepFrac |
	window := (SystemWindow labelled: 'later') model: aBrowser.
	hSepFrac := 0.3.
	window 
		addMorph: ((PluggableListMorph on: aBrowser list: #messageCatListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageCategoryMenu:) enableDragNDrop: true)
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@0) 
				offsets: (0@0 corner: 0@25)
		).
	window 
		addMorph: aBrowser buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@hSepFrac) 
				offsets: (0@25 corner: 0@0)
		).

	aBrowser 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.
	window setUpdatablePanesFrom: #(messageCatListSingleton messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 11:51'!
openBrowser: aBrowser asMorphSysCatEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	| window hSepFrac switchHeight mySingletonList nextOffsets |

	window := (SystemWindow labelled: 'later') model: aBrowser.
	hSepFrac := 0.30.
	switchHeight := 25.
	mySingletonList := PluggableListMorph on: aBrowser list: #systemCategorySingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #systemCatSingletonMenu: keystroke: #systemCatSingletonKey:from:.
 	mySingletonList enableDragNDrop: true.
	mySingletonList hideScrollBarsIndefinitely.
	window 
		addMorph: mySingletonList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@0) 
				offsets: (0@0  corner: 0@switchHeight)
		).	

	aBrowser 
		addClassAndSwitchesTo: window 
		at: (0@0 corner: 0.3333@hSepFrac)
		plus: switchHeight.

	nextOffsets := 0@switchHeight corner: 0@0.
	window 
		addMorph: aBrowser buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0.3333@0 corner: 0.6666@hSepFrac) 
				offsets: nextOffsets
		).	

	window 
		addMorph: aBrowser buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.6666@0 corner: 1@hSepFrac) 
				offsets: nextOffsets
		).	

	aBrowser 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.

	window setUpdatablePanesFrom: #( classList messageCategoryList messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 15:00'!
openChangeList: aChangeList asMorphName: labelString multiSelect: multiSelect
	"Open a morphic view for the messageSet, whose label is labelString. 
	The listView may be either single or multiple selection type"
	| window listHeight listPane |
	listHeight := 0.4.
	window := (SystemWindow labelled: labelString)
				model: aChangeList.
	listPane := multiSelect
				ifTrue: [PluggableListMorphOfMany
						on: aChangeList
						list: #list
						primarySelection: #listIndex
						changePrimarySelection: #toggleListIndex:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: (aChangeList showsVersions
								ifTrue: [#versionsMenu:]
								ifFalse: [#changeListMenu:])]
				ifFalse: [PluggableListMorph
						on: aChangeList
						list: #list
						selected: #listIndex
						changeSelected: #toggleListIndex:
						menu: (aChangeList showsVersions
								ifTrue: [#versionsMenu:]
								ifFalse: [#changeListMenu:])].
	listPane keystrokeActionSelector: #changeListKey:from:.
	window
		addMorph: listPane
		frame: (0 @ 0 extent: 1 @ listHeight).
	aChangeList
		addLowerPanesTo: window
		at: (0 @ listHeight corner: 1 @ 1)
		with: nil.
	^ window openInWorld! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 17:07'!
openChangeSorterAsMorph: aChangeSorter
	^aChangeSorter morphicWindow openInWorld! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 3/30/2011 16:26'!
openComparisionFrom: targetMethodSource
					to: originalMethodSource
					belongingTo: aClass
					from: aChange 
					labeled: aLabel 
					inWindowLabeled: aWindowLabel 
	| diffMorph diffBuilder difference win |
	PolymorphSystemSettings usePolymorphDiffMorph 
		ifTrue:[ ^ self openPolymorphComparisonFrom: originalMethodSource 
					to: targetMethodSource
					belongingTo: aClass
					from: aChange
					labeled: aLabel
					inWindowLabeled: aWindowLabel   ].
	diffBuilder :=  TextDiffBuilder
			from: originalMethodSource 
			to: targetMethodSource.
	difference := diffBuilder buildDisplayPatch.
	win := Workspace openContents: difference.
	win label: aLabel.
					
				! !

!MorphicUIManager methodsFor: 'services' stamp: 'JuanVuletich 10/22/2010 13:48'!
openDebugger: aDebugger fullMorphicLabel: aLabelString
	"Open a full morphic debugger with the given label"

	| window aListMorph oldContextStackIndex |
	oldContextStackIndex := aDebugger contextStackIndex.
	aDebugger expandStack. "Sets contextStackIndex to zero."

	window := (SystemWindow labelled: aLabelString) model: aDebugger.
	aListMorph := PluggableListMorph on: aDebugger list: #contextStackList
			selected: #contextStackIndex changeSelected: #toggleContextStackIndex:
			menu: #contextStackMenu:shifted: keystroke: #contextStackKey:from:.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph
		frame: (0@0 corner: 1@0.25).

	aDebugger addLowerPanesTo: window at: (0@0.25 corner: 1@0.8) with: nil.

	window addMorph: ((
		PluggableListMorph new
			doubleClickSelector: #inspectSelection;

			on: aDebugger receiverInspector list: #fieldList
			selected: #selectionIndex changeSelected: #toggleIndex:
			menu: #fieldListMenu: keystroke: #inspectorKey:from:) 
		autoDeselect: false)
			"For doubleClick to work best disable autoDeselect"
			
		frame: (0@0.8 corner: 0.2@1).
	window addMorph: (PluggableTextMorph on: aDebugger receiverInspector
			text: #contents accept: #accept:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (0.2@0.8 corner: 0.5@1).
	window addMorph: (
		PluggableListMorph new
			doubleClickSelector: #inspectSelection;

			on: aDebugger contextVariablesInspector list: #fieldList
			selected: #selectionIndex changeSelected: #toggleIndex:
			menu: #fieldListMenu: keystroke: #inspectorKey:from:)
		frame: (0.5@0.8 corner: 0.7@1).
	window addMorph: (PluggableTextMorph on: aDebugger contextVariablesInspector
			text: #contents accept: #accept:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (0.7@0.8 corner: 1@1).
	window openInWorld.
	aDebugger toggleContextStackIndex: oldContextStackIndex.
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/21/2011 19:06'!
openDebuggerOn: process context: context label: title contents: contentsStringOrNil fullView: bool 
	"Open a notifier in response to an error, halt, or notify. A notifier view
	just shows a short view of the sender stack and provides a menu that
	lets the user open a full debugger."
	| errorWasInUIProcess |
	errorWasInUIProcess := self spawnNewProcessIfThisIsUI: process.
	WorldState
		addDeferredUIMessage: [[| debugger | 
			debugger := Debugger new
						process: process
						controller: nil
						context: context.
			"schedule debugger in deferred UI message to address
			redraw problems after opening a debugger e.g. from
			the testrunner."
			"WorldState addDeferredUIMessage: ["
			bool
				ifTrue: [debugger openFullNoSuspendLabel: title]
				ifFalse: [debugger openNotifierContents: contentsStringOrNil label: title].
			debugger errorWasInUIProcess: errorWasInUIProcess.
			Debugger logDebuggerStackToFile
				ifTrue: [Smalltalk
						logError: title
						inContext: context ]]
				on: Error
				do: [:ex | Debugger primitiveError: 'Orginal error: ' , title asString , '.
	Debugger error: '
							, ([ex description]
									on: Error
									do: ['a ' , ex class printString]) , ':']].
	process suspend! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 17:08'!
openDualChangeSorterAsMorph: aDualChangeSorter
	^aDualChangeSorter morphicWindow openInWorld! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 14:18'!
openInspector: inspectorClass asMorphOn: anObject withLabel: aLabel 
	"(Inspector openAsMorphOn: SystemOrganization withLabel: 'Test') openInWorld"
	| window inspector |
	inspector := inspectorClass inspect: anObject.
	window := (SystemWindow labelled: aLabel)
				model: inspector.
	window
		addMorph: ((PluggableListMorph new doubleClickSelector: #inspectSelection;
				
				on: inspector
				list: #fieldList
				selected: #selectionIndex
				changeSelected: #toggleIndex:
				menu: #fieldListMenu:
				keystroke: #inspectorKey:from:) 
				autoDeselect: false )
				"For doubleClick to work best disable autoDeselect"
		frame: (0 @ 0 corner: inspectorClass horizontalDividerProportion @ inspectorClass verticalDividerProportion).
	window
		addMorph: (PluggableTextMorph
				on: inspector
				text: #contents
				accept: #accept:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:)
		frame: (inspectorClass horizontalDividerProportion @ 0 corner: 1 @ inspectorClass verticalDividerProportion).
	window
		addMorph: ((PluggableTextMorph
				on: inspector
				text: #trash
				accept: #trash:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:)
				askBeforeDiscardingEdits: false)
		frame: (0 @ inspectorClass verticalDividerProportion corner: 1 @ 1).
	window setUpdatablePanesFrom: #(#fieldList ).
	window position: 16 @ 0.
	"Room for scroll bar."
	^ window! !

!MorphicUIManager methodsFor: 'private' stamp: 'FernandoOlivero 3/10/2011 12:06'!
openModal: aSystemWindow 
	"Open the given window an available position without modality.
	Answer the system window."
	
	|baseArea areas searching foundRect|
	aSystemWindow extent: aSystemWindow initialExtent.
	areas := World submorphs
		select: [:m | m isKindOf: DialogWindow]
		thenCollect: [:m | m bounds expandBy: 8].
	baseArea := RealEstateAgent maximumUsableArea insetBy: 8.
	searching := true.
	baseArea allAreasOutsideList: areas do: [:rect |
		searching ifTrue: [
			aSystemWindow extent <= (rect insetBy: 8) extent
				ifTrue: [foundRect := rect.
						searching := false]]].
	searching ifTrue: [foundRect := baseArea].
	aSystemWindow setWindowColor: self theme windowColor.
	aSystemWindow position: foundRect topLeft + 8.
	aSystemWindow openAsIs.
	^aSystemWindow! !

!MorphicUIManager methodsFor: 'private' stamp: 'FernandoOlivero 3/30/2011 16:26'!
openPolymorphComparisonFrom: targetMethodSource
					to: originalMethodSource
					belongingTo: aClass
					from: aChange 
					labeled: aLabel 
					inWindowLabeled: aWindowLabel 
	| diffMorph |
	diffMorph := DiffChangeMorph
		from: targetMethodSource
		label: aChange stamp
		to: originalMethodSource
		label: (aClass compiledMethodAt: aChange methodSelector) timeStamp
		contextClass: aClass.
	diffMorph openInWindowLabeled: aWindowLabel.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 14:08'!
openProcessBrowserAsMorph: aProcessBrowser
	"Create a pluggable version of aProcessBrowser, answer a window"
	| window aTextMorph |
	window := (SystemWindow labelled: 'later')
				model: aProcessBrowser.

	aProcessBrowser deferredMessageRecipient: WorldState.
	window
		addMorph: ((PluggableListMorph
				on: aProcessBrowser
				list: #processNameList
				selected: #processListIndex
				changeSelected: #processListIndex:
				menu: #processListMenu:
				keystroke: #processListKey:from:)
				enableDragNDrop: false)
		frame: (0 @ 0 extent: 0.5 @ 0.5).
	window
		addMorph: ((PluggableListMorph
				on: aProcessBrowser
				list: #stackNameList
				selected: #stackListIndex
				changeSelected: #stackListIndex:
				menu: #stackListMenu:
				keystroke: #stackListKey:from:)
				enableDragNDrop: false)
		frame: (0.5 @ 0.0 extent: 0.5 @ 0.5).
	aTextMorph := PluggableTextMorph
				on: aProcessBrowser
				text: #selectedMethod
				accept: nil
				readSelection: nil
				menu: nil.
	aTextMorph askBeforeDiscardingEdits: false.
	window
		addMorph: aTextMorph
		frame: (0 @ 0.5 corner: 1 @ 1).
	window setUpdatablePanesFrom: #(#processNameList #stackNameList ).
	(window setLabel: 'Process Browser') openInWorld.
	aProcessBrowser mayBeStartCPUWatcher.
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 5/9/2011 12:14'!
openTranscript
	self world
		findAWindowSatisfying: [:aWindow | aWindow isKindOf: TranscriptWindow ]
		orMakeOneUsing: [TranscriptWindow  on: Smalltalk tools transcript  ] ! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'FernandoOlivero 5/9/2011 13:14'!
preferredCornerStyle
	^ self theme preferredCornerStyle! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 14:26'!
progressInitiationExceptionDefaultAction: anException

	anException defaultMorphicAction! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 10/19/2010 16:29'!
request: aStringOrText initialAnswer: defaultAnswer 
	^ self request: aStringOrText initialAnswer: defaultAnswer title: 'Information Required' translated
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 7/17/2010 13:17'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels."


	 ^ self 
		request: queryString 
		initialAnswer: defaultAnswer 
		
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/26/2010 10:19'!
request: aStringOrText initialAnswer: defaultAnswer entryCompletion: anEntryCompletion
	^ self request: aStringOrText initialAnswer: defaultAnswer title: 'Information Required' translated entryCompletion: anEntryCompletion
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle
	"Create an instance of me whose question is queryString with the given 
	initial answer. Answer the string the user accepts.
	The title serves for the window that is opened
	Answer the empty string if the user cancels.
	Allow for interception with a ProvideAnswerNotification handler."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme 
		textEntryIn: self modalMorph
		text: aStringOrText
		title: aTitle
		entryText: defaultAnswer)! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle entryCompletion: anEntryCompletion
	"Create an instance of me whose question is queryString with the given 
	initial answer. Answer the string the user accepts.
	The title serves for the window that is opened
	Answer the empty string if the user cancels.
	Allow for interception with a ProvideAnswerNotification handler."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme
		textEntryIn: self modalMorph
		text: aStringOrText
		title: aTitle
		entryText: defaultAnswer
		entryCompletion: anEntryCompletion)! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
requestPassword: aStringOrText 
	"Request for a password.
	Allow for interception with a ProvideAnswerNotification handler.
	Answer nil if the user cancels."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #default ifTrue: [''] ifFalse: [answer]].
	^ self theme
		passwordEntryIn: self modalMorph
		text: aStringOrText
		title: 'Password Required' translated
		entryText: ''! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 13:22'!
restoreDisplay

	World fullRepaintNeeded! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 13:18'!
restoreDisplayAfter: aBlock

	aBlock value.
	Sensor waitButton.
	World fullRepaintNeeded.! !

!MorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:11'!
resumeUIProcess: aProcess
	"Adopt aProcess as the project process -- probably because of proceeding from a debugger"

	Project resumeProcess: aProcess! !

!MorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:07'!
spawnNewProcessIfThisIsUI: suspendedProcess
	^Project spawnNewProcessIfThisIsUI: suspendedProcess.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 20:30'!
syntaxErrorNotificationDefaultAction: anException

	^ToolSet debugSyntaxError: anException! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 2/25/2011 17:53'!
theme 
	"Return the current theme"
	
	^ UITheme current 	
	
! !

!MorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:13'!
uiProcess

	^Project uiProcess! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 4/27/2007 15:53'!
unhandledErrorDefaultAction: anException

	"The current computation is terminated. The cause of the error should be logged or reported to the user. If the program is operating in an interactive debugging environment the computation should be suspended and the debugger activated."
	^ToolSet debugError: anException.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 4/27/2007 16:52'!
warningDefaultAction: anException

"The user should be notified of the occurrence of an exceptional occurrence and given an option of continuing or aborting the computation. The description of the occurrence should include any text specified as the argument of the #signal: message."
	ToolSet
		debugContext: thisContext
		label: 'Warning'
		contents: anException messageText, '\\Select Proceed to continue, or close this window to cancel the operation.' withCRs.
	anException resume.! !

!MorphicUIManager methodsFor: 'global state' stamp: 'FernandoOlivero 5/1/2011 11:40'!
world
	^ ActiveWorld ! !

ToolBuilder subclass: #MorphicToolBuilder
	instanceVariableNames: 'widgets panes parentMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!MorphicToolBuilder commentStamp: 'ar 2/11/2005 15:02' prior: 0!
The Morphic tool builder.!

!MorphicToolBuilder class methodsFor: 'accessing' stamp: 'alain.plantec 5/30/2008 13:55'!
isActiveBuilder
	"Answer whether I am the currently active builder"
	^ true! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 7/17/2005 00:00'!
add: aMorph to: aParent
	aParent addMorphBack: aMorph.
	aParent isSystemWindow ifTrue:[
		aParent addPaneMorph: aMorph.
	].! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'stephaneducasse 2/3/2006 22:35'!
asFrame: aRectangle
	| frame |
	aRectangle ifNil:[^nil].
	frame := LayoutFrame new.
	frame 
		leftFraction: aRectangle left; 
		rightFraction: aRectangle right; 
		topFraction: aRectangle top; 
		bottomFraction: aRectangle bottom.
	^frame! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'btr 11/26/2006 12:49'!
buildHelpFor: widget spec: aSpec
	aSpec help
		ifNotNil: [widget setBalloonText: aSpec help]! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 8/7/2009 19:40'!
buildPluggableActionButton: aSpec
	| button |
	button := self buildPluggableButton: aSpec.
	button color: Color white.
	^button! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'StephaneDucasse 7/31/2010 19:21'!
buildPluggableButton: aSpec

	| widget label state action enabled |
	label := aSpec label.
	state := aSpec state.
	action := aSpec action.
	widget := self buttonClass 
					on: aSpec model
 					getState: (state isSymbol ifTrue: [state])
  					action: nil
 					label: (label isSymbol ifTrue: [label]).
	self register: widget id: aSpec name.
	enabled := aSpec enabled.
	enabled isSymbol
		ifTrue: [widget getEnabledSelector: enabled]
		ifFalse: [widget enabled:enabled].
	action isSymbol
		ifTrue: [widget action: action]
		ifFalse: [widget actionBlock: action].
	widget getColorSelector: aSpec color.
	widget offColor: Color white..
	self buildHelpFor: widget spec: aSpec.
	(label isSymbol or: [label == nil]) ifFalse: [widget label: label].
	self setFrame: aSpec frame in: widget.
	parent ifNotNil: [self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'AlainPlantec 3/25/2010 09:19'!
buildPluggableCodePane: aSpec
	"Install the default styler for code panes.
	Implementation note: We should just be doing something like, e.g.,
		^(self buildPluggableText: aSpec) useDefaultStyler
	Unfortunately, this will retrieve and layout the initial text twice which
	can make for a noticable performance difference when looking at some
	larger piece of code. So instead we copy the implementation from 
	buildPlugggableText: here and insert #useDefaultStyler at the right point"
	| widget |
	widget := self codePaneClass new.
	widget useDefaultStyler.
	widget on: aSpec model
				text: aSpec getText 
				accept: aSpec setText
				readSelection: aSpec selection 
				menu: aSpec menu.
	widget font: StandardFonts codeFont.
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	widget borderColor: Color lightGray.
	widget color: Color white.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'md 8/15/2005 17:55'!
buildPluggableInputField: aSpec
	| widget |
	widget := self buildPluggableText: aSpec.
	widget acceptOnCR: true.
	widget hideScrollBarsIndefinitely.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:32'!
buildPluggableList: aSpec
	| widget listClass getIndex setIndex |
	aSpec getSelected ifNil:[
		listClass := self listClass.
		getIndex := aSpec getIndex.
		setIndex := aSpec setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := aSpec getSelected.
		setIndex := aSpec setSelected.
	].
	widget := listClass on: aSpec model
				list: aSpec list
				selected: getIndex
				changeSelected: setIndex
				menu: aSpec menu
				keystroke: aSpec keyPress.
	self register: widget id: aSpec name.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	widget doubleClickSelector: aSpec doubleClick.
	widget dragItemSelector: aSpec dragItem.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget autoDeselect: aSpec autoDeselect.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableMultiSelectionList: aSpec
	| widget listClass |
	aSpec getSelected ifNotNil:[^self error:'There is no PluggableListMorphOfManyByItem'].
	listClass := self multiSelectListClass.
	widget := listClass on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	self register: widget id: aSpec name.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggablePanel: aSpec
	| widget children frame |
	widget := self panelClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget color: Color transparent.
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	self buildAll: children in: widget.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	widget layoutInset: 0.
	widget borderWidth: 0.
	widget submorphsDo:[:sm|
		(frame := sm layoutFrame) ifNotNil:[
			(frame rightFraction = 0 or:[frame rightFraction = 1]) 
				ifFalse:[frame rightOffset:1].
			(frame bottomFraction = 0 or:[frame bottomFraction = 1]) 
				ifFalse:[frame bottomOffset: 1]]].
	widget color: Color transparent.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'AlainPlantec 3/25/2010 09:20'!
buildPluggableText: aSpec
	| widget |
	widget := self textPaneClass on: aSpec model
				text: aSpec getText 
				accept: aSpec setText
				readSelection: aSpec selection 
				menu: aSpec menu.
	widget askBeforeDiscardingEdits: aSpec askBeforeDiscardingEdits.
	widget font: StandardFonts codeFont.
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	widget borderColor: Color lightGray.
	widget color: Color white.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableTree: aSpec
	| widget |
	widget := self treeClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget getSelectedPathSelector: aSpec getSelectedPath.
	widget setSelectedSelector: aSpec setSelected.
	widget getChildrenSelector: aSpec getChildren.
	widget hasChildrenSelector: aSpec hasChildren.
	widget getLabelSelector: aSpec label.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec help.
	widget getMenuSelector: aSpec menu.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getRootsSelector: aSpec roots.
	widget autoDeselect: aSpec autoDeselect.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget dragItemSelector: aSpec dragItem.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
"	panes ifNotNil:[
		aSpec roots ifNotNil:[panes add: aSpec roots].
	].	"
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableWindow: aSpec
	| widget children label |
	aSpec layout == #proportional ifFalse:[
		"This needs to be implemented - probably by adding a single pane and then the rest"
		^self error: 'Not implemented'.
	].
	widget := self windowClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	(label := aSpec label) ifNotNil:[
		label isSymbol 
			ifTrue:[widget getLabelSelector: label]
			ifFalse:[widget setLabel: label]].
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	widget closeWindowSelector: aSpec closeAction.
	panes := OrderedCollection new.
	self buildAll: children in: widget.
	self buildHelpFor: widget spec: aSpec. 
	widget bounds: (RealEstateAgent 
		initialFrameFor: widget 
		initialExtent: (aSpec extent ifNil:[widget initialExtent])
		world: self currentWorld).
	widget setUpdatablePanesFrom: panes.
	^widget! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'MarcusDenker 7/29/2010 20:37'!
buttonClass
	^ PluggableButtonMorph! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:40'!
close: aWidget
	"Close a previously opened widget"
	aWidget delete! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'stephaneDucasse 7/18/2010 12:03'!
codePaneClass
	^ PluggableTextMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'stephaneDucasse 7/18/2010 11:53'!
listByItemClass
	^ PluggableListMorphByItem! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'StephaneDucasse 7/18/2010 13:43'!
listClass
	^ PluggableListMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
menuClass
	^ MenuMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
menuItemClass
	^ MenuItemMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:14'!
multiSelectListClass
	^ PluggableListMorphOfMany! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 10/4/2009 22:47'!
open: anObject
	"Build and open the object. Answer the widget opened."
	| morph |
	anObject isMorph 
		ifTrue:[morph := anObject]
		ifFalse:[morph := self build: anObject].
	(morph isKindOf: MenuMorph)
		ifTrue:[morph popUpInWorld: World].
	(morph isKindOf: SystemWindow)
		ifTrue:[morph openInWorldExtent: morph extent]
		ifFalse:[morph openInWorld].
	^morph! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:40'!
open: anObject label: aString
	"Build an open the object, labeling it appropriately.  Answer the widget opened."
	| window |
	window := self open: anObject.
	window setLabel: aString.
	^window! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:14'!
panelClass
	^ PluggablePanelMorph! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 9/6/2009 16:14'!
register: widget id: id
	id ifNil:[^self].
	widgets ifNil:[widgets := Dictionary new].
	widgets at: id put: widget.
	widget setNameTo: id.! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:41'!
runModal: aWidget
	"Run the (previously opened) widget modally, e.g., 
	do not return control to the sender before the user has responded."
	[aWidget world notNil] whileTrue: [
		aWidget outermostWorldMorph doOneCycle.
	].
! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'dc 1/10/2008 14:17'!
setFrame: aRectangle in: widget
	| frame |
	aRectangle ifNil:[^nil].
	frame := aRectangle isRectangle
		ifTrue: [self asFrame: aRectangle]
		ifFalse: [aRectangle]. "assume LayoutFrame"
	widget layoutFrame: frame.
	widget hResizing: #spaceFill; vResizing: #spaceFill.
	(parent isSystemWindow) ifTrue:[
		widget borderWidth: 2; borderColor: #inset.
	].! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 9/16/2009 23:11'!
setLayout: layout in: widget
	layout == #proportional ifTrue:[
		widget layoutPolicy: ProportionalLayout new.
		^self].
	layout == #horizontal ifTrue:[
		widget layoutPolicy: TableLayout new.
		widget listDirection: #leftToRight.
		widget submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
		widget cellInset: 1@1.
		widget layoutInset: 1@1.
		widget color: Color transparent.
		"and then some..."
		^self].
	layout == #vertical ifTrue:[
		widget layoutPolicy: TableLayout new.
		widget listDirection: #topToBottom.
		widget submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
		widget cellInset: 1@1.
		widget layoutInset: 1@1.
		widget color: Color transparent.
		"and then some..."
		^self].
	^self error: 'Unknown layout: ', layout.! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'StephaneDucasse 7/17/2010 15:44'!
textPaneClass
	^ PluggableTextMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:16'!
treeClass
	^ PluggableTreeMorph! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 7/14/2005 22:30'!
widgetAt: id ifAbsent: aBlock
	widgets ifNil:[^aBlock value].
	^widgets at: id ifAbsent: aBlock! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:16'!
windowClass
	^ PluggableSystemWindow! !

AlignmentMorph subclass: #PluggablePanelMorph
	instanceVariableNames: 'model getChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggablePanelMorph commentStamp: 'ar 2/11/2005 20:13' prior: 0!
A pluggable panel morph which deals with changing children.!

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector
	^getChildrenSelector! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model
	^model! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model: aModel
	model ifNotNil:[model removeDependent: self].
	model := aModel.
	model ifNotNil:[model addDependent: self].! !

!PluggablePanelMorph methodsFor: 'update' stamp: 'marcus.denker 9/14/2008 18:59'!
update: what
	what ifNil: [^self].
	what == getChildrenSelector ifTrue:[
		self removeAllMorphs.
		self addAllMorphs: (model perform: getChildrenSelector).
		self submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].! !
